#!/bin/bash

#-------------------------------------------------------------
# Skript zur Erstellung eines konsisten Image eines 
# entfernten Rechners, hier ein RasPi
# ------------------------------------------------------------

# Kostanten, die jeweils zu besetzen sind
remote=IP_des_remote_Rechner
remote_pw=Passwort_fuer_root_auf_remote
remote_ssh_port=ssh_port_auf_remote
backup_dir=Verzeichnis_derSicherung

# per plink (=ssh + Ausführung) auf den entfernten Rechner verbinden
# und ein Skript zur Erstellung des gezipten Image aufrufen;
# das gezipte Image liegt auf dem eigenen Rechner, nicht auf dem Remote,
# dafür sorgt das Skript mkimg2hubi2.sh
plink root@$remote -P $remote_ssh_port -pw $remote_pw "./mkimg2pc.sh"
#exit

cd $backup_dir

# die gesicherte Datei bestimmen, ist die neueste im Backupverzeichnis
zipfile=`ls -tp *.gz | grep -v /$ | head -n 1`

# file auspacken
gunzip $zipfile

# Name des Images bestimmen
img=`ls -tp *.img | grep -v /$ | head -n 1`

echo "Image file = $img"


# Sektorgröße bestimmen
sectorsize=`fdisk -l $img | grep "sector.*=" | cut -d' ' -f6`
echo "sectorsize=$sectorsize"

# alle Partitionen im Image überprüfen
for i in {1..9}
do
	# Startsektor bestimmen
	start=`fdisk -l $img | grep img$i | tr -s " " | cut -d' ' -f2`
	if [ "$start" != "" ]
	then
		echo "check $(fdisk -l $img | grep img$i | cut -d' ' -f1)"
		echo "start=$start"
		offset=$((start * sectorsize))
		echo "offset=$offset"
		# partition als Loop-Device einhänge
		losetup --offset $offset /dev/loop2 $img
		# und auf Fehler prüfen und korrigieren
		fsck /dev/loop2 -f -p
		losetup -d /dev/loop2
		echo ""
	fi
done

echo "neues zip anlegen: ${img}.gz"
pv $img | gzip -c > "${img}.gz" 

if [ -e "${img}.gz" ]; then
	rm $img
fi

exit
